
/***************************************************************************
 *            ho_recognize_font_3.h
 *
 *  Fri Aug 12 20:13:33 2005
 *  Copyright  2005-2008  Yaacov Zamir
 *  <kzamir@walla.co.il>
 ****************************************************************************/

/*  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/** @file ho_recognize_font_3.h
    @brief libhocr C language header.
    
    libhocr - LIBrary for Hebrew Optical Character Recognition 
*/

#ifndef HO_RECOGNIZE_FONT_3_H
#define HO_RECOGNIZE_FONT_3_H 1

double ho_recognize_font_3_zero (const double *array_in);

double ho_recognize_font_3_one (const double *array_in);

double ho_recognize_font_3_two (const double *array_in);

double ho_recognize_font_3_three (const double *array_in);

double ho_recognize_font_3_four (const double *array_in);

double ho_recognize_font_3_five (const double *array_in);

double ho_recognize_font_3_six (const double *array_in);

double ho_recognize_font_3_seven (const double *array_in);

double ho_recognize_font_3_eight (const double *array_in);

double ho_recognize_font_3_nine (const double *array_in);

double ho_recognize_font_3_dot (const double *array_in);

double ho_recognize_font_3_comma (const double *array_in);

double ho_recognize_font_3_open (const double *array_in);

double ho_recognize_font_3_close (const double *array_in);

double ho_recognize_font_3_minus (const double *array_in);

double ho_recognize_font_3_plus (const double *array_in);

double ho_recognize_font_3_div (const double *array_in);

double ho_recognize_font_3_tag (const double *array_in);

double ho_recognize_font_3_two_tags (const double *array_in);

double ho_recognize_font_3_question (const double *array_in);

double ho_recognize_font_3_exclem (const double *array_in);

double ho_recognize_font_3_dot_dot (const double *array_in);

double ho_recognize_font_3_dot_comma (const double *array_in);

double ho_recognize_font_3_alef (const double *array_in);

double ho_recognize_font_3_bet (const double *array_in);

double ho_recognize_font_3_gimal (const double *array_in);

double ho_recognize_font_3_dalet (const double *array_in);

double ho_recognize_font_3_hey (const double *array_in);

double ho_recognize_font_3_vav (const double *array_in);

double ho_recognize_font_3_zayin (const double *array_in);

double ho_recognize_font_3_het (const double *array_in);

double ho_recognize_font_3_tet (const double *array_in);

double ho_recognize_font_3_yud (const double *array_in);

double ho_recognize_font_3_caf (const double *array_in);

double ho_recognize_font_3_caf_sofit (const double *array_in);

double ho_recognize_font_3_lamed (const double *array_in);

double ho_recognize_font_3_mem (const double *array_in);

double ho_recognize_font_3_mem_sofit (const double *array_in);

double ho_recognize_font_3_nun (const double *array_in);

double ho_recognize_font_3_nun_sofit (const double *array_in);

double ho_recognize_font_3_samech (const double *array_in);

double ho_recognize_font_3_ayin (const double *array_in);

double ho_recognize_font_3_pey (const double *array_in);

double ho_recognize_font_3_pey_sofit (const double *array_in);

double ho_recognize_font_3_tzadi (const double *array_in);

double ho_recognize_font_3_tzadi_sofit (const double *array_in);

double ho_recognize_font_3_kuf (const double *array_in);

double ho_recognize_font_3_resh (const double *array_in);

double ho_recognize_font_3_shin (const double *array_in);

double ho_recognize_font_3_tav (const double *array_in);

#endif /* HO_RECOGNIZE_FONT_3_H */
